ViennaCL - The Vienna Computing Library: viennacl::basic_slice< SizeType, DistanceType > Class Template Reference

ViennaCL - The Vienna Computing Library 1.7.1 Free open-source GPU-accelerated linear algebra and solver library. |

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | List of all members
viennacl::basic_slice< SizeType, DistanceType > Class Template Reference

A slice class that refers to an interval [start, stop), where 'start' is included, and 'stop' is excluded. More...

`#include <forwards.h>`

## Public Types
typedef SizeT | size_type
typedef DistanceT | difference_type
typedef size_type | value_type
typedef value_type | const_reference
typedef const_reference | reference

## Public Member Functions
| basic_slice ()
| basic_slice (size_type start_index, size_type stride_arg, size_type size_arg)
size_type | start () const
size_type | stride () const
size_type | size () const
const_reference | operator() (size_type i) const
const_reference | operator[] (size_type i) const
bool | operator== (const basic_slice &s) const
bool | operator!= (const basic_slice &s) const

## Detailed Description

### template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>
class viennacl::basic_slice< SizeType, DistanceType >

A slice class that refers to an interval [start, stop), where 'start' is included, and 'stop' is excluded.

Similar to the boost::numeric::ublas::basic_range class.

Definition at line 429 of file forwards.h.

## Member Typedef Documentation

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

typedef value_type viennacl::basic_slice< SizeType, DistanceType >::const_reference

Definition at line 45 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

typedef DistanceT viennacl::basic_slice< SizeType, DistanceType >::difference_type

Definition at line 43 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

typedef const_reference viennacl::basic_slice< SizeType, DistanceType >::reference

Definition at line 46 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

typedef SizeT viennacl::basic_slice< SizeType, DistanceType >::size_type

Definition at line 42 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

typedef size_type viennacl::basic_slice< SizeType, DistanceType >::value_type

Definition at line 44 of file slice.hpp.

## Constructor & Destructor Documentation

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

viennacl::basic_slice< SizeType, DistanceType >::basic_slice | ( |  | ) |
| inline

Definition at line 48 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

viennacl::basic_slice< SizeType, DistanceType >::basic_slice | ( | size_type | start_index,
|  | size_type | stride_arg,
|  | size_type | size_arg
| ) |  |
| inline

Definition at line 49 of file slice.hpp.

## Member Function Documentation

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

bool viennacl::basic_slice< SizeType, DistanceType >::operator!= | ( | const basic_slice< SizeType, DistanceType > & | s | ) | const
| inline

Definition at line 66 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

const_reference viennacl::basic_slice< SizeType, DistanceType >::operator() | ( | size_type | i | ) | const
| inline

Definition at line 58 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

bool viennacl::basic_slice< SizeType, DistanceType >::operator== | ( | const basic_slice< SizeType, DistanceType > & | s | ) | const
| inline

Definition at line 65 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

const_reference viennacl::basic_slice< SizeType, DistanceType >::operator[] | ( | size_type | i | ) | const
| inline

Definition at line 63 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

size_type viennacl::basic_slice< SizeType, DistanceType >::size | ( |  | ) | const
| inline

Definition at line 56 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

size_type viennacl::basic_slice< SizeType, DistanceType >::start | ( |  | ) | const
| inline

Definition at line 54 of file slice.hpp.

template<typename SizeType = vcl_size_t, typename DistanceType = std::ptrdiff_t>

size_type viennacl::basic_slice< SizeType, DistanceType >::stride | ( |  | ) | const
| inline

Definition at line 55 of file slice.hpp.

The documentation for this class was generated from the following files:

- viennacl/forwards.h
- viennacl/slice.hpp